# 5.2.0

Release date: `2021-05-14`

## Core

- [NXDRIVE-826](https://jira.nuxeo.com/browse/NXDRIVE-826): Add OAuth 2 capabilities
- [NXDRIVE-2332](https://jira.nuxeo.com/browse/NXDRIVE-2332): Poll for the `batchId` on a regular basic to prevent its purgation from the transient store
- [NXDRIVE-2371](https://jira.nuxeo.com/browse/NXDRIVE-2371): Secure storage of the token in the database
- [NXDRIVE-2403](https://jira.nuxeo.com/browse/NXDRIVE-2403): Add support for ADFS authentication
- [NXDRIVE-2581](https://jira.nuxeo.com/browse/NXDRIVE-2581): Add the synchronization feature
- [NXDRIVE-2606](https://jira.nuxeo.com/browse/NXDRIVE-2606): Catch `TypeError` in `RemoteFileInfo.from_dict()`
- [NXDRIVE-2607](https://jira.nuxeo.com/browse/NXDRIVE-2607): Handle invalid data returned by the server when asking for a `batchId`
- [NXDRIVE-2609](https://jira.nuxeo.com/browse/NXDRIVE-2609): Handle HTTP 504 (Gateway Time-out) errors
- [NXDRIVE-2610](https://jira.nuxeo.com/browse/NXDRIVE-2610): Remove the `TRACE` logging level, obsolete since 4.1.0
- [NXDRIVE-2612](https://jira.nuxeo.com/browse/NXDRIVE-2612): Save all features state in the local configuration file
- [NXDRIVE-2617](https://jira.nuxeo.com/browse/NXDRIVE-2617): Move to `cryptography` module for cryptography stuff
- [NXDRIVE-2619](https://jira.nuxeo.com/browse/NXDRIVE-2619): Remove `Engine` databases on failed account addition
- [NXDRIVE-2620](https://jira.nuxeo.com/browse/NXDRIVE-2620): Ignore `RuntimeError: wrapped C/C++ object of type LinkingAction has been deleted` in `Action.finish()`
- [NXDRIVE-2622](https://jira.nuxeo.com/browse/NXDRIVE-2622): Fix parsing of paths in local configuration file
- [NXDRIVE-2623](https://jira.nuxeo.com/browse/NXDRIVE-2623): Ignore `RuntimeError: wrapped C/C++ object of type QueueManager has been deleted` in `QueueManager.push_error()`
- [NXDRIVE-2624](https://jira.nuxeo.com/browse/NXDRIVE-2624): Handle HTTP 408 (Request Timeout) errors
- [NXDRIVE-2627](https://jira.nuxeo.com/browse/NXDRIVE-2627): Add support for OpenID Connect Discovery
- [NXDRIVE-2630](https://jira.nuxeo.com/browse/NXDRIVE-2630): [Windows] Cannot use UNC paths for the `nxdrive_home` parameter
- [NXDRIVE-2631](https://jira.nuxeo.com/browse/NXDRIVE-2631): Refetch local configuration on `nxdrive_home` change
- [NXDRIVE-2633](https://jira.nuxeo.com/browse/NXDRIVE-2633): Do not watch the local folder parent
- [NXDRIVE-2636](https://jira.nuxeo.com/browse/NXDRIVE-2636): Handle HTTP 405 (Method Not Allowed) errors
- [NXDRIVE-2639](https://jira.nuxeo.com/browse/NXDRIVE-2639): Fix locale settings persistence

### Direct Edit

- [NXDRIVE-2608](https://jira.nuxeo.com/browse/NXDRIVE-2608): Handle HTTP 502 (Bad Gateway), 503 (Service Unavailable) and 504 (Gateway Time-out) errors
- [NXDRIVE-2621](https://jira.nuxeo.com/browse/NXDRIVE-2621): Handle HTTPError 404 (Not Found) errors
- [NXDRIVE-2632](https://jira.nuxeo.com/browse/NXDRIVE-2632): Add the `dt_hide_personal_space` option to hide the "Personal space" remote location

### Direct Transfer

- [NXDRIVE-2625](https://jira.nuxeo.com/browse/NXDRIVE-2625): Prevent constraint error when pausing an Upload
- [NXDRIVE-2635](https://jira.nuxeo.com/browse/NXDRIVE-2635): Do not follow symlinks

## GUI

- [NXDRIVE-2583](https://jira.nuxeo.com/browse/NXDRIVE-2583): Add a new settings tab when the synchronization is enabled
- [NXDRIVE-2604](https://jira.nuxeo.com/browse/NXDRIVE-2604): Change tabs order on Settings screen
- [NXDRIVE-2618](https://jira.nuxeo.com/browse/NXDRIVE-2618): Improve Accounts tab on Settings

## Packaging / Build

- [NXDRIVE-2629](https://jira.nuxeo.com/browse/NXDRIVE-2629): Upgrade from Python 3.9.4 to 3.9.5
- [NXDRIVE-2637](https://jira.nuxeo.com/browse/NXDRIVE-2637): Fix pyenv initialization for our release process

## Tests

- [NXDRIVE-2602](https://jira.nuxeo.com/browse/NXDRIVE-2602): Remove unnecessary Codecov token usage
- [NXDRIVE-2603](https://jira.nuxeo.com/browse/NXDRIVE-2603): Fix `test_flooding_prevention()` when run from `tox`
- [NXDRIVE-2605](https://jira.nuxeo.com/browse/NXDRIVE-2605): Declare early the `remote` attribute in `Engine`

## Docs

- [NXDRIVE-2](https://jira.nuxeo.com/browse/NXDRIVE-2):

## Minor Changes

- Added `authlib` 0.15.3
- Added `cryptography` 3.4.7
- Added `jwt` 1.2.0
- Upgraded `docutils` from 0.17 to 0.17.1
- Upgraded `nuxeo` from 5.0.0 to 6.0.0
- Upgraded `pyinstaller` from 4.2 to 4.3
- Upgraded `pyobjc-core` from 7.1 to 7.2
- Upgraded `pyobjc-framework-cocoa` from 7.1 to 7.2
- Upgraded `pyobjc-framework-coreservices` from 7.1 to 7.2
- Upgraded `pyobjc-framework-fsevents` from 7.1 to 7.2
- Upgraded `pyobjc-framework-scriptingbridge` from 7.1 to 7.2
- Upgraded `pyobjc-framework-systemconfiguration` from 7.1 to 7.2
- Upgraded `sentry-sdk` from 1.0.0 to 1.1.0
- Upgraded `six` from 1.15.0 to 1.16.0
- Upgraded `watchdog` from 0.10.3 to 2.1.1
- Removed `pathtools`
- Removed `pycryptodomex`

## Technical Changes

- Added `Application.synchronization_feature_model`
- Added `details` keyword argument to `Application.display_warning()`
- Changed `CliHandler.load_config()` return type from `None` to `Dict[str, Any`
- Removed the `parser` argument from `CliHandler.load_config()`
- Updated `DirectEdit.directEditError` signal signature from `(str, list)` to `([str, list], [str, list, str])`
- Updated `Engine.authChanged` signal signature from `()` to `(str)`
- Updated `Engine.uiChanged` signal signature from `()` to `(str)`
- Updated `EngineModel.authChanged` signal signature from `()` to `(str)`
- Updated `EngineModel.uiChanged` signal signature from `()` to `(str)`
- Added `restart_needed` keyword argument to `FeatureModel.__init__()`
- Added `Feature.synchronization`
- Added `FeatureModel.restart_needed` property.
- Added `Manager.get_engine_db()`
- Added `Manager.remove_engine_dbs()`
- Added `setter` keyword argument to `Manager.set_feature_state()`
- Added `Options.dt_hide_personal_space`
- Added `Options.oauth2_authorization_endpoint`
- Added `Options.oauth2_client_id`
- Added `Options.oauth2_client_secret`
- Added `Options.oauth2_openid_configuration_url`
- Added `Options.oauth2_redirect_uri`
- Added `Options.oauth2_scope`
- Added `Options.oauth2_token_endpoint`
- Added `QMLDriveApi.continue_oauth2_flow()`
- Added `use_legacy_auth` argument to `QMLDriveApi.web_authentication()`, its signal signature was modified from `(str, str)` to `(str, str, bool)`
- Removed all arguments from `Remote.request_token()`
- Added auth/
- Removed engine/watcher/local_watcher.py::`DriveFSRootEventHandler`
- Removed `lazy` keyword argument from utils.py::`decrypt()`
- Removed `lazy` keyword argument from utils.py::`encrypt()`
- Added utils.py::`get_config_path()`
